<!DOCTYPE html>
<html lang="en">

<head>
	<title>voucher</title>
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width, initial-scale=1">
	<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
	<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
	<script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

	<!-- Import Datatable sau jquery -->
	<!-- Import them style bootstrap cho datatable -->
	<link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
	<script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
	<script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>

<body>

	<div class="container">
		<h2 style="text-align: center;">Quản trị Voucher</h2>
		<div class="jumbotron container">
			<div class="row form-group">
				<div class="col-sm-3">
					<label for="voucher-code">Phần Trăm Giảm Giá</label>
				</div>
				<div class="col-sm-9">
					<input type="text" id="input-discount" name="phanTramGiamGia" placeholder="Phần trăm giảm giá"
						class="form-control">
				</div>
			</div>
			<div class="row form-group">
				<div class="col-sm-3">
					<label for="discount">Ghi chú</label>
				</div>
				<div class="col-sm-9">
					<input type="text" id="input-note" name="ghiChu" placeholder="Ghi chú"
						class="form-control">
				</div>
			</div>
			<div class="row form-group">
				<div class="col-sm-3">
					<label for="note">Mã Voucher</label>
				</div>
				<div class="col-sm-9">
					<input type="text" id="input-voucher-code" name="maVoucher" placeholder="Mã voucher" class="form-control">
				</div>
			</div>
			<div class="row form-group">
				<div class="col-sm-3">
					<label for="updateDate">Ngày tạo</label>
				</div>
				<div class="col-sm-9">
					<input type="date" id="input-ngay-tao" name="newDate" placeholder="Ngày tạo" class="form-control">
				</div>
			</div>
			<div class="row form-group">
				<div class="col-sm-3">
					<label for="updateDate">Ngày sửa</label>
				</div>
				<div class="col-sm-9">
					<input type="date" id="input-updateDate" name="updateDate" placeholder="Update Date"
						class="form-control">
				</div>
			</div>
			<div class="row pull-right">
				<div>
					<button id="detail" class="btn btn-info">Detail</button>
				</div>
				<div class="ml-2">
					<button id="delete_data" class="btn btn-danger">Delete Data</button>
				</div>
				<div class="ml-2">
					<button id="delete_data_all" class="btn btn-danger">Delete All Data</button>
				</div>
			</div>
		</div>
		<table class="table table-bordered table-striped table-hover" id="user-table">
			<thead>
				<tr>
					<th>ID</th>
					<th>Phần trăm giảm giá</th>
					<th>Ghi chú</th>
					<th>Mã voucher</th>
					<th>Ngày tạo</th>
					<th>Ngày cập nhật</th>
				</tr>
		</table>
	</div>
	<script>



		$(document).ready(function () {
			var gID = "";
			var gFORM_MODE_INSERT = "Insert";
			var gFORM_MODE_UPDATE = "Update";
			var gFormMode = gFORM_MODE_INSERT;

			var table = $("#user-table").DataTable({
				"columns": [
					{ "data": "id" },
					{ "data": "phanTramGiamGia" },
					{ "data": "ghiChu" },
					{ "data": "maVoucher" },
					{ "data": "ngayTao" },
					{ "data": "ngayCapNhat" },
				]
			})

			$.ajax({
				url: "http://localhost:8080/vouchers",
				type: "GET",
				dataType: "json",
				success: function (res) {
					console.log(res);
					table.clear();
					table.rows.add(res);
					table.draw();
				},
				error: function (err) {
					console.log(err.response);
				}
			});



			$(document).on('click', "tr", function () {
				onBtnDetailClick(this);
			})

			$(document).on('click', "#delete_data", function () {
				onBtnDeleteClick(this);
			})

			$(document).on('click', "#delete_data_all", function () {
				onBtnAllDeleteClick(this);
			})

			$(document).on('click', "#detail", function () {
				onBtnSaveDataClick(this)
			})

			function onBtnDetailClick(paramElement) {

				gFormMode = gFORM_MODE_UPDATE;
				var vRowSelected = $(paramElement).closest("tr");
				var vTable = $("#user-table").DataTable();
				var vDataRow = vTable.row(vRowSelected).data();
				gID = vDataRow.id;
				$.ajax({
					url: "http://localhost:8080/vouchers/" + gID,
					type: 'GET',
					success: function (res) {
						console.log(res);
						$("#input-discount").val(res.phanTramGiamGia);
						$("#input-note").val(res.ghiChu);
						$("#input-voucher-code").val(res.maVoucher);
						let vCreateDate = res.ngayTao.slice(6, 10) + "-" + res.ngayTao.slice(3.5) + res.ngayTao.slice(0, 2);
						$("#input-ngay-tao").val(vCreateDate);
						if (res.ngayCapNhat != null) {
							let vUpdateDate = res.ngayCapNhat.slice(6, 10) + "-" + res.ngayCapNhat.slice(3.5) + res.ngayCapNhat.slice(0, 2);
							$("#input-updateDate").val(vUpdateDate);
						} else {
							$("#input-updateDate").val("");
						}

					},
					error: function (err) {
						console.log(err.status)
					}
				})
			}

			function onBtnSaveDataClick() {
				if (gFormMode === gFORM_MODE_UPDATE) {
					let vObjectRequest = {
						id: gID,
						phanTramGiamGia: $("#input-discount").val(),
						ghiChu: $("#input-note").val(),
						maVoucher: $("#input-voucher-code").val(),
					};

					$.ajax({
						url: "http://localhost:8080/update-voucher/" + gID,
						contentType: "application/json; charset=UTF-8",
						type: 'PUT',
						dataType: "json",
						data: JSON.stringify(vObjectRequest),
						success: function (res) {
							window.location.reload();
						},
						error: function (err) {
							console.log(err.status)
						}
					})
				}else {
					let vObjectRequest = {
						id: gID,
						phanTramGiamGia: $("#input-discount").val(),
						ghiChu: $("#input-note").val(),
						maVoucher: $("#input-voucher-code").val(),
					}
					$.ajax({
						url: "http://localhost:8080/created-voucher/",
						contentType: "application/json; Charset=UFT-8",
						type: 'POST',
						dataType: "json",
						data: JSON.stringify(vObjectRequest),
						success: function (res) {
							window.location.reload();
						},
						error: function (err) {
							console.log(err.status)
						}
					})
				}
			}

			function onBtnDeleteClick() {
				if(confirm("bạn có muốn xóa?") == true) {


					$.ajax({
						url: "http://localhost:8080/delete-voucher/" + gID,
						type: "DELETE",
						dataType: "json",
						success: function(res) {
							window.location.reload();
						},
						error: function(err) {
							console.log(err.response);
						}
					})
				}
			}

			function onBtnAllDeleteClick() {
				if(confirm("bạn có muốn xóa hết toàn bộ danh sách drink?") == true) {
					$.ajax({
						url: "http://localhost:8080/delete-voucher",
						type: "DELETE",
						dataType: "json",
						success: function(res) {
							window.location.reload();
						},
						error: function(err) {
							console.log(err.response);
						}
					})
				}
			}


		});



	</script>
</body>

</html>